module breakout (clk, reset, l, r, ballX, ballY, paddleX, bricks);

input clk, reset, l, r;
output [9:0] ballX, paddleX;
output [8:0] ballY;
output [59:0] bricks;

reg [9:0] ballX, paddleX;
reg [8:0] ballY;
reg [59:0] bricks, newBricks;
reg [5:0] bricknum;
reg inBrick;
reg [1:0] balldir, tmpDir;

wire [9:0] tmpXa, tmpXb;
wire [8:0] tmpYa, tmpYb;
wire hittingBrick;

assign hittingBrick = (bricknum == 62 || bricknum == 63) ? 1 : bricks[bricknum];

inbrick moduleA(tmpXa, tmpYa, bricknum);
nextBallPos moduleB(balldir, ballX, ballY, tmpXa, tmpYa);
nextBallPos moduleC(tmpDir, ballX, ballY, tmpXb, tmpYb);
nextBallDir moduleD(balldir, ballX, ballY, tmpDir);

// calculate the paddle's next position
always @(posedge clk) begin
  if (reset)
    paddleX <= 320;
  else if (l)
    paddleX <= paddleX - 2;
  else if (r)
    paddleX <= paddleX + 2;
end

// calculate the ball's next position, and the bricks
always @(posedge clk) begin
  if (reset) begin
    
  end else begin
    bricks[bricknum] <= 0;
    if (hittingBrick) begin
      ballX <= tmpXb;
      ballY <= tmpYb;
      balldir <= tmpDir;
    end else begin
      ballX <= tmpXa;
      ballY <= tmpYa;
    end
  end    
end

endmodule



module inbrick(bx, by, bricknum);

input [9:0] bx;
input [8:0] by;
output [5:0] bricknum;

assign bricknum = 10 * by[8:5] + bx[9:6] - 30;

endmodule



module nextBallPos(bdir, bx, by, outx, outy);

input [1:0] bdir;
input [9:0] bx;
input [8:0] by;
output [9:0] outx;
output [8:0] outy;

assign outx = (bdir[1]) ? (bx + 2) : (bx - 2);
assign outy = (bdir[0]) ? (by + 2) : (by - 2);

endmodule


module nextBallDir(bdir, bx, by, outdir);

input [1:0] bdir;
input [9:0] bx;
input [8:0] by;
output [1:0] outdir;

wire [4:0] xpos;
wire [3:0] ypos;

assign xpos = bx[4:0];
assign ypos = by[3:0];

// A thought... is xpos or ypos EVER odd?
assign outdir[1] = (bx > 638 || xpos == 0 || xpos == 1 || xpos == 2 || xpos == 30 || xpos == 31) ? ~bdir[1] : bdir[1];
assign outdir[0] = (by > 478 || ypos == 0 || ypos == 1 || ypos == 2 || ypos == 14 || ypos == 15) ? ~bdir[0] : bdir[0];

endmodule
