module ClkGen(clk, mclk, lrclk, sclk);
input clk;
output mclk, lrclk, sclk;

reg mclk, lrclk, sclk;

reg [2:0] master;
reg [5:0] data;
reg [10:0] lrchannel;

//parameters
parameter MASTER_C	= 3;	//25Mhz / 4Mhz = ~6Mhz 
parameter SERIAL_DATA	= 12;	//1/4 of MCLK = SCLK
parameter LR_CHANNEL	= 32;	//1.024MHz / 16KHz = 64


always @(posedge clk) begin
	master = master + 1;
	data = data + 1;

	
	if(master == MASTER_C) begin
		mclk = !mclk;
		master = 0;
	end
	
	if(data == SERIAL_DATA) begin
		sclk = !sclk;
		data = 0;
	end
	
	
end


always @(negedge sclk) begin
	lrchannel = lrchannel + 1;	
	if(lrchannel == LR_CHANNEL) begin
		lrclk = !lrclk;
		lrchannel = 0;
	end
end
endmodule
