module CODE_READER (CLK, KEY, RST, UP, DOWN, RIGHT, LEFT, START) ;

input CLK;
input [7:0] KEY;
output RST;
output UP;
output DOWN;
output RIGHT;
output LEFT;
output START;

reg RST, UP, DOWN, RIGHT, LEFT, START;

reg [1:0] COUNT;

always @(posedge CLK) begin

    if(!COUNT) begin
      COUNT[0] <= 1;
      if(KEY == 8'b00101101) begin //R key
        RST <= 1;  //reset
        COUNT <= 0;
        UP <= 0;
        DOWN <= 0;
        RIGHT <= 0;
        LEFT <= 0;
        RST <= 0;
        START <= 0;
      end
      if(KEY == 8'b01001101) //P key
        START <= 1;  //up
      if(KEY == 8'b00011101) //W key
        UP <= 1;  //up
      else if(KEY == 8'b00011011) //S key
        DOWN <= 1;  //down
      else if(KEY == 8'b00100011) //D key
        RIGHT <= 1;  //right
      else if(KEY == 8'b00011100) //A key
        LEFT <= 1;  //left
    end
    else begin
      if(COUNT[1]) COUNT[1] <= 0;
      else COUNT <= COUNT + 1;
      UP <= 0;
      DOWN <= 0;
      RIGHT <= 0;
      LEFT <= 0;
      RST <= 0;
      START <= 0;
    end

end

endmodule 
