module translator(CLK, NK, scancode, NI, instr);

input CLK;
input NK;
input [7:0] scancode;
output NI;
output [15:0] instr;

reg NI;
reg [15:0] instr;

reg [1:0] count;
reg [15:0] temp;

always @ (posedge CLK) begin
  
  if( NK ) begin
  
	  case (scancode)
	  	
	    8'h5A: begin // start to push the number
	      if (count == 1) begin
	        instr[3:0] <= temp[11:8];
	        instr[11:4] <= 0;
	      end
	      else if (count == 2) begin
	        instr[7:0] <= temp[11:4];
	        instr[11:8] <= 0;
	      end
	      else if (count == 3) begin
	        instr <= temp;
	      end
	      
	      // do the opcode
	      instr[15:12] <= 4'hF;
	      NI <= 1;
	      count <= 0;
	    end
	    
	    // Copy the number to the temp
	    8'h70, 8'h69, 8'h72, 8'h7A, 8'h6B, 8'h73, 8'h74, 8'h6C, 8'h75, 8'h7D,
	    8'h45, 8'h16, 8'h1E, 8'h26, 8'h25, 8'h2E, 8'h36, 8'h3D, 8'h3E, 8'h46, 8'h1C, 8'h32, 8'h21, 8'h23, 8'h24, 8'h2B:  begin
	      // copy the data and assert the NI when we got all 3 input numbers
	      if (count == 0) begin
	        case(scancode)
	          8'h70, 8'h45: begin // 0
	            temp[11:8] <= 0;
	           end
	          8'h69, 8'h16: begin // 1 
	            temp[11:8] <= 1;
	          end
	          8'h72, 8'h1E: begin // 2
	            temp[11:8] <= 2;
	          end
	          8'h7A, 8'h26: begin //3
	            temp[11:8] <= 3;
	          end
	          8'h6B, 8'h25: begin //4
	            temp[11:8] <= 4;
	          end
	          8'h73, 8'h2E: begin //5
	            temp[11:8] <= 5;
	          end
	          8'h74, 8'h36: begin //6
	            temp[11:8] <= 6;
	          end
	          8'h6C, 8'h3D: begin //7
	            temp[11:8] <= 7;
	          end
	          8'h75, 8'h3E: begin //8
	            temp[11:8] <= 8;
	          end
	          8'h7D, 8'h46:begin //9
	            temp[11:8] <= 9;
	          end
	          8'h1C: begin //A
	            temp[11:8] <= 10;
	          end
	          8'h32: begin //B
	            temp[11:8] <= 11;
	          end
	          8'h21: begin //C
	            temp[11:8] <= 12;
	          end
	          8'h23: begin //D
	            temp[11:8] <= 13;
	          end
	          8'h24: begin //E
	            temp[11:8] <= 14;
	          end
	          8'h2B: begin //F
	            temp[11:8] <= 15;
	          end	          
	        endcase 
	        count <= 1;
	      end
	      else if (count == 1) begin
	        case(scancode) 
	          8'h70, 8'h45: begin // 0
	            temp[7:4] <= 0;
	           end
	          8'h69, 8'h16: begin // 1 
	            temp[7:4] <= 1;
	          end
	          8'h72, 8'h1E: begin // 2
	            temp[7:4] <= 2;
	          end
	          8'h7A, 8'h26: begin //3
	            temp[7:4] <= 3;
	          end
	          8'h6B, 8'h25: begin //4
	            temp[7:4] <= 4;
	          end
	          8'h73, 8'h2E: begin //5
	            temp[7:4] <= 5;
	          end
	          8'h74, 8'h36: begin //6
	            temp[7:4] <= 6;
	          end
	          8'h6C, 8'h3D: begin //7
	            temp[7:4] <= 7;
	          end
	          8'h75, 8'h3E: begin //8
	            temp[7:4] <= 8;
	          end
	          8'h7D, 8'h46:begin //9
	            temp[7:4] <= 9;
	          end
	          8'h1C: begin //A
	            temp[7:4] <= 10;
	          end
	          8'h32: begin //B
	            temp[7:4] <= 11;
	          end
	          8'h21: begin //C
	            temp[7:4] <= 12;
	          end
	          8'h23: begin //D
	            temp[7:4] <= 13;
	          end
	          8'h24: begin //E
	            temp[7:4] <= 14;
	          end
	          8'h2B: begin //F
	            temp[7:4] <= 15;
	          end	          
	        endcase 
	        count <= 2;
	      end
	      else if (count == 2) begin
	        case(scancode)
	          8'h70, 8'h45: begin // 0
	            temp[3:0] <= 0;
	           end
	          8'h69, 8'h16: begin // 1 
	            temp[3:0] <= 1;
	          end
	          8'h72, 8'h1E: begin // 2
	            temp[3:0] <= 2;
	          end
	          8'h7A, 8'h26: begin //3
	            temp[3:0] <= 3;
	          end
	          8'h6B, 8'h25: begin //4
	            temp[3:0] <= 4;
	          end
	          8'h73, 8'h2E: begin //5
	            temp[3:0] <= 5;
	          end
	          8'h74, 8'h36: begin //6
	            temp[3:0] <= 6;
	          end
	          8'h6C, 8'h3D: begin //7
	            temp[3:0] <= 7;
	          end
	          8'h75, 8'h3E: begin //8
	            temp[3:0] <= 8;
	          end
	          8'h7D, 8'h46:begin //9
	            temp[3:0] <= 9;
	          end
	          8'h1C: begin //A
	            temp[3:0] <= 10;
	          end
	          8'h32: begin //B
	            temp[3:0] <= 11;
	          end
	          8'h21: begin //C
	            temp[3:0] <= 12;
	          end
	          8'h23: begin //D
	            temp[3:0] <= 13;
	          end
	          8'h24: begin //E
	            temp[3:0] <= 14;
	          end
	          8'h2B: begin //F
	            temp[3:0] <= 15;
	          end	          
	        endcase
	        count <= 3;
	      end
	      else begin
	        count <= 3;
	      end
	    end
	    
	    8'h79:  begin // add 
	      instr[15:12] <= 4'h8;
	      instr[11:0] <= 0;
	      NI <= 1;
	    end
	    
	    8'h7B:  begin // subtract
	      instr[15:12] <= 4'h9;
	      instr[11:0] <= 0;
	      NI <= 1;
	    end
	    
	    8'h7C:  begin // multiply
	      instr[15:12] <= 4'hA;
	      instr[11:0] <= 0;
	      NI <= 1;
	    end 
	    
	    8'h1B:  begin // clear
	      instr[15:12] <= 4'h2;
	      instr[11:0] <= 0;
	      NI <= 1;
	    end 
	  endcase
   end
   
   if(~NK) begin
     NI <=0;
   end     
     	  
end

endmodule     
  
			

