module SIG_CTRL (CLK, RST, SIN, UIN, DIN, RIN, LIN, START, UP, DOWN, RIGHT, LEFT, READ) ;

input RST;
input CLK;
input READ;
input SIN;
input UIN;
input DIN;
input RIN;
input LIN;
output START;
output UP;
output DOWN;
output RIGHT;
output LEFT;

reg START, START_O;
reg UP, UP_O;
reg DOWN, DOWN_O;
reg RIGHT, RIGHT_O;
reg LEFT, LEFT_O;

always @(posedge CLK) begin
  if(RST) begin
    START <= 0;
    START_O <= 0;
    UP <= 0;
    UP_O <= 0;
    DOWN <= 0;
    DOWN_O <= 0;
    RIGHT <= 0;
    RIGHT_O <= 0;
    LEFT <= 0;
    LEFT_O <= 0;
  end
  else begin
    if(READ) begin
      START <= 0;
      UP <= 0;
      DOWN <= 0;
      RIGHT <= 0;
      LEFT <= 0;
    end
    else begin
      if(START_O != SIN) begin
      	START <= SIN;
      	START_O <= SIN;
      end
      if(UP_O != UP) begin
        UP <= UIN;
        UP_O <= UIN;
      end
      if(DOWN_O != DIN) begin
        DOWN <= DIN;
        DOWN_O <= DIN;
      end
      if(RIGHT_O != RIN) begin
        RIGHT <= RIN;
        RIGHT_O <= RIN;
      end
      if(LEFT_O != LIN) begin
        LEFT <= LIN;
        LEFT_O <= LIN;
      end
    end
  end
end

endmodule 
