module TargetMove (clk, inBus, stroked, X, Y) ;


wire right; // X++
wire left ; // X--
wire up ; // Y++
wire down ; // Y--
input clk;
input [7:0] inBus;
input stroked;
output [9:0] X ;
output [9:0] Y ;

reg [7:0] inBus;
reg [31:0] counter;
reg [9:0] X, Y;
integer Xvec, Yvec;
reg startup;
parameter UPDATE_FREQUENCY = 1000000;
parameter XMIN = 20, XMAX = 587, YMIN = 20, YMAX = 427;

assign down =    (inBus == 8'b00011101) && stroked; //W
assign up =  (inBus == 8'b00011011) && stroked; //S
assign left =  (inBus == 8'b00011100) && stroked; //A
assign right = (inBus == 8'b00100011) && stroked; //D

always @(posedge clk)
begin
	if(!startup)
	begin
		X <= 200;
		Y <= 200;
		Xvec <= 0;
		Yvec <= 0;
		startup = 1;
	end
	
	if (counter > UPDATE_FREQUENCY)
		counter <= 0;
	else
		counter <= counter + 1;
	
      	if(counter == 0)
	begin
		if(X + Xvec > XMIN && X + Xvec < XMAX)
			X <= X + Xvec;
		else
			Xvec <= -Xvec;
			
		if(Y + Yvec > YMIN && Y + Yvec < YMAX)
			Y <= Y + Yvec;
		else
			Yvec <= -Yvec;
	end
	else
	begin
		Xvec <= Xvec + right - left;
		Yvec <= Yvec + up - down;
	end
end

endmodule 
